Index: /branches/HTM-DEV-0.3-dev2/source/App/TAppDecoder/TAppDecTop.cpp
===================================================================
--- /branches/HTM-DEV-0.3-dev2/source/App/TAppDecoder/TAppDecTop.cpp	(revision 477)
+++ /branches/HTM-DEV-0.3-dev2/source/App/TAppDecoder/TAppDecTop.cpp	(revision 478)
@@ -683,4 +683,5 @@
 #endif
 #if H_3D_IV_MERGE
+// GT: This function is not necessary anymore m_ivPicLists should be used instead
 TComPic* TAppDecTop::xGetPicFromView( Int viewIdx, Int poc, Bool isDepth )
 {
@@ -701,4 +702,3 @@
 }
 #endif
-
 //! \}
Index: /branches/HTM-DEV-0.3-dev2/source/App/TAppDecoder/TAppDecTop.h
===================================================================
--- /branches/HTM-DEV-0.3-dev2/source/App/TAppDecoder/TAppDecTop.h	(revision 477)
+++ /branches/HTM-DEV-0.3-dev2/source/App/TAppDecoder/TAppDecTop.h	(revision 478)
@@ -76,5 +76,4 @@
     // for output control
   Bool                            m_abDecFlag[ MAX_GOP ];         ///< decoded flag in one GOP
-
 #if H_3D_IV_MERGE
   Int  m_fcoViewDepthId;
@@ -107,7 +106,4 @@
   TDecTop* getTDecTop     ( Int viewIdx, Bool isDepth );
   TComPic*              getPicFromView     ( Int viewIdx, Int poc, bool isDepth ) { return xGetPicFromView( viewIdx, poc, isDepth ); }
-#endif
-
-#if H_3D_IV_MERGE
   TComVPSAccess*    getVPSAccess  () { return &m_cVPSAccess;   }
   TComSPSAccess*    getSPSAccess  () { return &m_cSPSAccess;   }
@@ -124,5 +120,4 @@
   TComPic* xGetPicFromView( Int viewIdx, Int poc, Bool isDepth );
 #endif
-
 #if H_MV
   Void  xWriteOutput      ( TComList<TComPic*>* pcListPic, Int layerId, Int tId ); ///< write YUV to file
@@ -133,5 +128,4 @@
   Void  xFlushOutput      ( TComList<TComPic*>* pcListPic ); ///< flush all remaining decoded pictures to file
 #endif
-
   Bool  isNaluWithinTargetDecLayerIdSet ( InputNALUnit* nalu ); ///< check whether given Nalu is within targetDecLayerIdSet
 };
Index: /branches/HTM-DEV-0.3-dev2/source/App/TAppEncoder/TAppEncCfg.cpp
===================================================================
--- /branches/HTM-DEV-0.3-dev2/source/App/TAppEncoder/TAppEncCfg.cpp	(revision 477)
+++ /branches/HTM-DEV-0.3-dev2/source/App/TAppEncoder/TAppEncCfg.cpp	(revision 478)
@@ -717,5 +717,4 @@
 
 #endif //HHI_VSO
-
 #if H_3D_IV_MERGE
   ("PredDepthMapGen",  m_uiPredDepthMapGeneration, (UInt)0, "generation of prediction depth maps for motion data prediction" )
Index: /branches/HTM-DEV-0.3-dev2/source/App/TAppEncoder/TAppEncTop.cpp
===================================================================
--- /branches/HTM-DEV-0.3-dev2/source/App/TAppEncoder/TAppEncTop.cpp	(revision 477)
+++ /branches/HTM-DEV-0.3-dev2/source/App/TAppEncoder/TAppEncTop.cpp	(revision 478)
@@ -128,29 +128,8 @@
     m_frameRcvd                 .push_back(0);
     m_acTEncTopList             .push_back(new TEncTop); 
-#if H_3D_IV_MERGE
-//    m_acTEncDepthTopList        .push_back(new TEncTop); 
-#endif
     m_acTVideoIOYuvInputFileList.push_back(new TVideoIOYuv);
     m_acTVideoIOYuvReconFileList.push_back(new TVideoIOYuv);
     m_picYuvRec                 .push_back(new TComList<TComPicYuv*>) ;
-#if H_3D_IV_MERGE
-    //m_acTEncDepthTopList[iViewIdx]->setFrameRate                    ( m_iFrameRate );
-    //m_acTEncDepthTopList[iViewIdx]->setFrameSkip                    ( m_FrameSkip );
-    //m_acTEncDepthTopList[iViewIdx]->setSourceWidth                  ( m_iSourceWidth );
-    //m_acTEncDepthTopList[iViewIdx]->setSourceHeight                 ( m_iSourceHeight );
-    //m_acTEncDepthTopList[iViewIdx]->setCroppingMode                 ( m_croppingMode );
-    //m_acTEncDepthTopList[iViewIdx]->setCropLeft                     ( m_cropLeft );
-    //m_acTEncDepthTopList[iViewIdx]->setCropRight                    ( m_cropRight );
-    //m_acTEncDepthTopList[iViewIdx]->setCropTop                      ( m_cropTop );
-    //m_acTEncDepthTopList[iViewIdx]->setCropBottom                   ( m_cropBottom );
-    //m_acTEncDepthTopList[iViewIdx]->setFrameToBeEncoded             ( m_iFrameToBeEncoded );
-    //m_acTEncDepthTopList[iViewIdx]->setViewId                       ( iViewIdx );
-    //m_acTEncDepthTopList[iViewIdx]->setIsDepth                      ( true );
-
-    //m_acTEncDepthTopList[iViewIdx]->setViewOrderIdx                 ( m_cCameraData.getViewOrderIndex()[ iViewIdx ] );
-
-    //m_acTEncDepthTopList[iViewIdx]->setLayerId                      ( layerId );
-
-#endif
+
     m_ivPicLists.push_back( m_acTEncTopList[ layer ]->getListPic()  ); 
     TEncTop& m_cTEncTop = *m_acTEncTopList[ layer ];  // It is not a member, but this name helps avoiding code duplication !!!
@@ -164,10 +143,4 @@
     m_cTEncTop.setIsDepth                      ( isDepth );
     //====== Camera Parameters =========
-#if H_3D_IV_MERGE
-      //m_acTEncDepthTopList[iViewIdx]->setCamParPrecision              ( 0 );
-      //m_acTEncDepthTopList[iViewIdx]->setCamParInSliceHeader          ( false );
-      //m_acTEncDepthTopList[iViewIdx]->setCodedScale                   ( 0 );
-      //m_acTEncDepthTopList[iViewIdx]->setCodedOffset                  ( 0 );
-#endif
     m_cTEncTop.setCameraParameters             ( &m_cCameraData );     
     m_cTEncTop.setCamParPrecision              ( isDepth ? false : m_cCameraData.getCamParsCodedPrecision  () );
@@ -220,11 +193,4 @@
   
   //====== Coding Structure ========
-#if H_3D_IV_MERGE
-      //m_acTEncDepthTopList[iViewIdx]->setIntraPeriod                  ( m_iIntraPeriod );
-      //m_acTEncDepthTopList[iViewIdx]->setDecodingRefreshType          ( m_iDecodingRefreshType );
-      //m_acTEncDepthTopList[iViewIdx]->setGOPSize                      ( m_iGOPSize );
-      //m_acTEncDepthTopList[iViewIdx]->setGopList                      ( m_GOPListsMvc[iViewIdx] );
-      //m_acTEncDepthTopList[iViewIdx]->setExtraRPSs                    ( m_extraRPSs[iViewIdx] );
-#endif
   m_cTEncTop.setIntraPeriod                  ( m_iIntraPeriod );
   m_cTEncTop.setDecodingRefreshType          ( m_iDecodingRefreshType );
@@ -267,7 +233,4 @@
   {
     m_cTEncTop.setLambdaModifier( uiLoop, m_adLambdaModifier[ uiLoop ] );
-#if H_3D_IV_MERGE
-//        m_acTEncDepthTopList[iViewIdx]->setLambdaModifier( uiLoop, m_adLambdaModifier[ uiLoop ] );
-#endif
   }
 #if H_MV
@@ -289,11 +252,4 @@
   
   //====== Loop/Deblock Filter ========
-#if H_3D_IV_MERGE
-      //m_acTEncDepthTopList[iViewIdx]->setLoopFilterDisable            ( m_abLoopFilterDisable[1]   );
-      //m_acTEncDepthTopList[iViewIdx]->setLoopFilterOffsetInAPS        ( m_loopFilterOffsetInAPS );
-      //m_acTEncDepthTopList[iViewIdx]->setLoopFilterBetaOffset         ( m_loopFilterBetaOffsetDiv2  );
-      //m_acTEncDepthTopList[iViewIdx]->setLoopFilterTcOffset           ( m_loopFilterTcOffsetDiv2    );
-      //m_acTEncDepthTopList[iViewIdx]->setDeblockingFilterControlPresent( m_DeblockingFilterControlPresent);
-#endif
 #if H_MV
   m_cTEncTop.setLoopFilterDisable            ( m_bLoopFilterDisable[layer]);
@@ -1102,4 +1058,5 @@
 #endif
 #if H_3D_IV_MERGE
+ // GT: This function is not necessary anymore m_ivPicLists should be used instead
 TComPic* TAppEncTop::xGetPicFromView( Int viewIdx, Int poc, Bool isDepth )
 {
Index: /branches/HTM-DEV-0.3-dev2/source/App/TAppEncoder/TAppEncTop.h
===================================================================
--- /branches/HTM-DEV-0.3-dev2/source/App/TAppEncoder/TAppEncTop.h	(revision 477)
+++ /branches/HTM-DEV-0.3-dev2/source/App/TAppEncoder/TAppEncTop.h	(revision 478)
@@ -92,5 +92,4 @@
   TRenModel                   m_cRendererModel;   
 #endif
-
 #if H_3D_IV_MERGE
   TComVPSAccess               m_cVPSAccess;
@@ -145,5 +144,4 @@
   TEncTop&    getTEncTop  ()   { return  m_cTEncTop; }      ///< return encoder class pointer reference
 #endif
-
 #if H_3D_IV_MERGE
   TComVPSAccess*    getVPSAccess  () { return &m_cVPSAccess;   }
Index: /branches/HTM-DEV-0.3-dev2/source/Lib/TLibCommon/CommonDef.h
===================================================================
--- /branches/HTM-DEV-0.3-dev2/source/Lib/TLibCommon/CommonDef.h	(revision 477)
+++ /branches/HTM-DEV-0.3-dev2/source/Lib/TLibCommon/CommonDef.h	(revision 478)
@@ -211,5 +211,4 @@
 }
 #endif
-
 template <typename T>
 __inline T gSign(const T& t)
@@ -362,4 +361,5 @@
 
 #if H_3D_IV_MERGE
+ // GT: To be checked if all of this is still necessary. 
 #define PDM_USE_FOR_IVIEW                 1
 #define PDM_USE_FOR_INTER                 2
@@ -381,5 +381,4 @@
 
 #endif
-
 #endif // end of H_3D
 //! \}
Index: /branches/HTM-DEV-0.3-dev2/source/Lib/TLibCommon/TComDataCU.cpp
===================================================================
--- /branches/HTM-DEV-0.3-dev2/source/Lib/TLibCommon/TComDataCU.cpp	(revision 477)
+++ /branches/HTM-DEV-0.3-dev2/source/Lib/TLibCommon/TComDataCU.cpp	(revision 478)
@@ -2457,5 +2457,4 @@
   deriveLeftRightTopIdxGeneral( uiAbsPartIdx, uiPUIdx, uiPartIdxLT, uiPartIdxRT );
   deriveLeftBottomIdxGeneral  ( uiAbsPartIdx, uiPUIdx, uiPartIdxLB );
-
 #if H_3D_IV_MERGE
   Bool bNoPdmMerge   = ( m_pcSlice->getSPS()->getViewIndex() == 0 || ( m_pcSlice->getSPS()->getMultiviewMvPredMode() & PDM_USE_FOR_MERGE ) != PDM_USE_FOR_MERGE );
@@ -2603,5 +2602,4 @@
 #endif
 #endif
-
   //left
   UInt uiLeftPartIdx = 0;
@@ -2623,5 +2621,4 @@
       pcCULeft->getMvField( pcCULeft, uiLeftPartIdx, REF_PIC_LIST_1, pcMvFieldNeighbours[(iCount<<1)+1] );
     }
-
 #if H_3D_IV_MERGE 
     Bool bRemoveSpa = false; //pruning to inter-view candidates
@@ -4502,5 +4499,4 @@
 }
 #endif 
-
 #if H_3D_IV_MERGE
 Bool TComDataCU::getUnifiedMvPredCan(UInt uiPartIdx, RefPicList eRefPicList, Int iRefIdx, Int* paiPdmRefIdx, TComMv* pacPdmMv, DisInfo* pDInfo, Int* iPdm, Bool bMerge )
Index: /branches/HTM-DEV-0.3-dev2/source/Lib/TLibCommon/TComDataCU.h
===================================================================
--- /branches/HTM-DEV-0.3-dev2/source/Lib/TLibCommon/TComDataCU.h	(revision 477)
+++ /branches/HTM-DEV-0.3-dev2/source/Lib/TLibCommon/TComDataCU.h	(revision 478)
@@ -434,5 +434,4 @@
    
 #endif
-
 #if H_3D_IV_MERGE
   Bool          getUnifiedMvPredCan       ( UInt uiPartIdx, RefPicList eRefPicList, Int iRefIdx, Int* paiPdmRefIdx, TComMv* pacPdmMv, DisInfo* pDInfo, Int* iPdm, Bool bMerge );
Index: /branches/HTM-DEV-0.3-dev2/source/Lib/TLibCommon/TComDepthMapGenerator.cpp
===================================================================
--- /branches/HTM-DEV-0.3-dev2/source/Lib/TLibCommon/TComDepthMapGenerator.cpp	(revision 477)
+++ /branches/HTM-DEV-0.3-dev2/source/Lib/TLibCommon/TComDepthMapGenerator.cpp	(revision 478)
@@ -43,5 +43,5 @@
 #include "TComDepthMapGenerator.h"
 
-
+#if H_3D_IV_MERGE
 
 TComDepthMapGenerator::TComDepthMapGenerator()
@@ -136,6 +136,4 @@
 }
 
-
-#if H_3D_IV_MERGE
 Bool
 TComDepthMapGenerator::getPdmCandidate(TComDataCU* pcCU, UInt uiPartIdx, RefPicList eRefPicList, Int iRefIdx, Int* paiPdmRefIdx, TComMv* pacPdmMv, DisInfo* pDInfo, Int* iPdm, Bool bMerge )
Index: /branches/HTM-DEV-0.3-dev2/source/Lib/TLibCommon/TComDepthMapGenerator.h
===================================================================
--- /branches/HTM-DEV-0.3-dev2/source/Lib/TLibCommon/TComDepthMapGenerator.h	(revision 477)
+++ /branches/HTM-DEV-0.3-dev2/source/Lib/TLibCommon/TComDepthMapGenerator.h	(revision 478)
@@ -48,5 +48,5 @@
 #include "TComSlice.h"
 
-
+#if H_3D_IV_MERGE
 
 class TComVPSAccess // would be better to have a real VPS buffer
@@ -156,5 +156,5 @@
 
 
-
+#endif
 #endif // __TCOM_DEPTH_MAP_GENERATOR__
 
Index: /branches/HTM-DEV-0.3-dev2/source/Lib/TLibCommon/TComMotionInfo.h
===================================================================
--- /branches/HTM-DEV-0.3-dev2/source/Lib/TLibCommon/TComMotionInfo.h	(revision 477)
+++ /branches/HTM-DEV-0.3-dev2/source/Lib/TLibCommon/TComMotionInfo.h	(revision 478)
@@ -105,5 +105,4 @@
   Int getHor   () const { return  m_acMv.getHor(); }
   Int getVer   () const { return  m_acMv.getVer(); }
-
 #if H_3D_IV_MERGE
   Bool operator== ( const TComMvField& rcMv ) const
Index: /branches/HTM-DEV-0.3-dev2/source/Lib/TLibCommon/TComPicYuv.cpp
===================================================================
--- /branches/HTM-DEV-0.3-dev2/source/Lib/TLibCommon/TComPicYuv.cpp	(revision 477)
+++ /branches/HTM-DEV-0.3-dev2/source/Lib/TLibCommon/TComPicYuv.cpp	(revision 478)
@@ -84,5 +84,4 @@
   m_iBaseUnitHeight = uiMaxCUHeight >> uiMaxCUDepth;
 #endif
-
   Int numCuInWidth  = m_iPicWidth  / m_iCuWidth  + (m_iPicWidth  % m_iCuWidth  != 0);
   Int numCuInHeight = m_iPicHeight / m_iCuHeight + (m_iPicHeight % m_iCuHeight != 0);
Index: /branches/HTM-DEV-0.3-dev2/source/Lib/TLibCommon/TComSlice.cpp
===================================================================
--- /branches/HTM-DEV-0.3-dev2/source/Lib/TLibCommon/TComSlice.cpp	(revision 477)
+++ /branches/HTM-DEV-0.3-dev2/source/Lib/TLibCommon/TComSlice.cpp	(revision 478)
@@ -1857,5 +1857,4 @@
   }
 }
-
 #if H_3D_IV_MERGE
 Void
@@ -1871,5 +1870,4 @@
 }
 #endif
-
 const Int TComSPS::m_winUnitX[]={1,2,2,1};
 const Int TComSPS::m_winUnitY[]={1,2,1,1};
@@ -1942,5 +1940,4 @@
   m_bDepth                = false;
 #endif
-
   if( !m_bCamParInSliceHeader )
   {
@@ -1954,5 +1951,4 @@
   }
 }
-
 #if H_3D_IV_MERGE
 Void
Index: /branches/HTM-DEV-0.3-dev2/source/Lib/TLibCommon/TComSlice.h
===================================================================
--- /branches/HTM-DEV-0.3-dev2/source/Lib/TLibCommon/TComSlice.h	(revision 477)
+++ /branches/HTM-DEV-0.3-dev2/source/Lib/TLibCommon/TComSlice.h	(revision 478)
@@ -54,5 +54,4 @@
 class TComPicLists; 
 #endif
-
 #if H_3D_IV_MERGE
 class TComDepthMapGenerator;
Index: /branches/HTM-DEV-0.3-dev2/source/Lib/TLibDecoder/TDecCAVLC.cpp
===================================================================
--- /branches/HTM-DEV-0.3-dev2/source/Lib/TLibDecoder/TDecCAVLC.cpp	(revision 477)
+++ /branches/HTM-DEV-0.3-dev2/source/Lib/TLibDecoder/TDecCAVLC.cpp	(revision 478)
@@ -759,5 +759,4 @@
     }
 #endif // !H_MV
-
 #if H_3D_IV_MERGE
     READ_FLAG( uiCode, "base_view_flag" );
Index: /branches/HTM-DEV-0.3-dev2/source/Lib/TLibDecoder/TDecCu.cpp
===================================================================
--- /branches/HTM-DEV-0.3-dev2/source/Lib/TLibDecoder/TDecCu.cpp	(revision 477)
+++ /branches/HTM-DEV-0.3-dev2/source/Lib/TLibDecoder/TDecCu.cpp	(revision 478)
@@ -320,6 +320,6 @@
     m_ppcCU[uiDepth]->copyInterPredInfoFrom( pcCU, uiAbsPartIdx, REF_PIC_LIST_0 );
     m_ppcCU[uiDepth]->copyInterPredInfoFrom( pcCU, uiAbsPartIdx, REF_PIC_LIST_1 );
+#if H_3D_IV_MERGE
     m_ppcCU[uiDepth]->copyDVInfoFrom(pcCU, uiAbsPartIdx);
-#if H_3D_IV_MERGE
     TComMvField cMvFieldNeighbours[MRG_MAX_NUM_CANDS_MEM << 1]; // double length for mv of both lists
     UChar uhInterDirNeighbours[MRG_MAX_NUM_CANDS_MEM];
Index: /branches/HTM-DEV-0.3-dev2/source/Lib/TLibDecoder/TDecGop.cpp
===================================================================
--- /branches/HTM-DEV-0.3-dev2/source/Lib/TLibDecoder/TDecGop.cpp	(revision 477)
+++ /branches/HTM-DEV-0.3-dev2/source/Lib/TLibDecoder/TDecGop.cpp	(revision 478)
@@ -158,5 +158,4 @@
     m_LFCrossSliceBoundaryFlag.push_back( pcSlice->getLFCrossSliceBoundaryFlag());
   }
-
 #if H_3D_IV_MERGE
   if( uiStartCUAddr == 0 )
@@ -165,5 +164,4 @@
   }
 #endif
-
 #if H_3D_NBDV 
   if(pcSlice->getViewIndex() && !pcSlice->getIsDepth()) //Notes from QC: this condition shall be changed once the configuration is completed, e.g. in pcSlice->getSPS()->getMultiviewMvPredMode() || ARP in prev. HTM. Remove this comment once it is done.
Index: /branches/HTM-DEV-0.3-dev2/source/Lib/TLibDecoder/TDecGop.h
===================================================================
--- /branches/HTM-DEV-0.3-dev2/source/Lib/TLibDecoder/TDecGop.h	(revision 477)
+++ /branches/HTM-DEV-0.3-dev2/source/Lib/TLibDecoder/TDecGop.h	(revision 478)
@@ -54,5 +54,4 @@
 #include "TLibCommon/TComDepthMapGenerator.h"
 #endif
-
 #include "TDecEntropy.h"
 #include "TDecSlice.h"
@@ -86,5 +85,4 @@
   TComDepthMapGenerator*  m_pcDepthMapGenerator;
 #endif
-
   TComSampleAdaptiveOffset*     m_pcSAO;
   Double                m_dDecTime;
Index: /branches/HTM-DEV-0.3-dev2/source/Lib/TLibDecoder/TDecTop.cpp
===================================================================
--- /branches/HTM-DEV-0.3-dev2/source/Lib/TLibDecoder/TDecTop.cpp	(revision 477)
+++ /branches/HTM-DEV-0.3-dev2/source/Lib/TLibDecoder/TDecTop.cpp	(revision 478)
@@ -409,5 +409,4 @@
   m_cSliceDecoder.init( &m_cEntropyDecoder, &m_cCuDecoder );
   m_cEntropyDecoder.init(&m_cPrediction);
-
 #if H_3D_IV_MERGE
   m_tAppDecTop = pcTAppDecTop;
@@ -919,5 +918,4 @@
 
 #endif
-
 #if H_3D_IV_MERGE
     TComPic * const pcTexturePic = m_isDepth ? m_tAppDecTop->getPicFromView(  m_viewIndex, pcSlice->getPOC(), false ) : NULL;
Index: /branches/HTM-DEV-0.3-dev2/source/Lib/TLibEncoder/TEncCavlc.cpp
===================================================================
--- /branches/HTM-DEV-0.3-dev2/source/Lib/TLibEncoder/TEncCavlc.cpp	(revision 477)
+++ /branches/HTM-DEV-0.3-dev2/source/Lib/TLibEncoder/TEncCavlc.cpp	(revision 478)
@@ -581,5 +581,4 @@
   WRITE_FLAG( 0, "sps_extension_flag" );
 #endif
-
 #if H_3D_IV_MERGE
   if( pcSPS->getViewIndex() || pcSPS->isDepth() )
Index: /branches/HTM-DEV-0.3-dev2/source/Lib/TLibEncoder/TEncGOP.cpp
===================================================================
--- /branches/HTM-DEV-0.3-dev2/source/Lib/TLibEncoder/TEncGOP.cpp	(revision 477)
+++ /branches/HTM-DEV-0.3-dev2/source/Lib/TLibEncoder/TEncGOP.cpp	(revision 478)
@@ -682,5 +682,5 @@
 #endif
 
-#if H_3D_IV_MERGE
+#if H_3D_IV_MERGE 
     TAppEncTop* tAppEncTop = m_pcEncTop->getEncTop();
     TComPic * const pcTexturePic = m_pcEncTop->getIsDepth() ? tAppEncTop->getPicFromView( getViewIndex(), pcSlice->getPOC(), false ) : NULL;
@@ -1042,9 +1042,7 @@
     m_storedStartCUAddrForEncodingSliceSegment.push_back(nextCUAddr);
     startCUAddrSliceSegmentIdx++;
-
 #if H_3D_IV_MERGE
     m_pcDepthMapGenerator->initViewComponent( pcPic );
 #endif
-
 #if H_3D_NBDV
       if(pcSlice->getViewIndex() && !pcSlice->getIsDepth()) //Notes from QC: this condition shall be changed once the configuration is completed, e.g. in pcSlice->getSPS()->getMultiviewMvPredMode() || ARP in prev. HTM. Remove this comment once it is done.
Index: /branches/HTM-DEV-0.3-dev2/source/Lib/TLibEncoder/TEncGOP.h
===================================================================
--- /branches/HTM-DEV-0.3-dev2/source/Lib/TLibEncoder/TEncGOP.h	(revision 477)
+++ /branches/HTM-DEV-0.3-dev2/source/Lib/TLibEncoder/TEncGOP.h	(revision 478)
@@ -110,9 +110,7 @@
   Int                     m_viewIndex; 
   Bool                    m_isDepth;
-
 #if H_3D_IV_MERGE
   TComDepthMapGenerator*  m_pcDepthMapGenerator;
 #endif
-
 #endif
 #endif
Index: /branches/HTM-DEV-0.3-dev2/source/Lib/TLibEncoder/TEncTop.cpp
===================================================================
--- /branches/HTM-DEV-0.3-dev2/source/Lib/TLibEncoder/TEncTop.cpp	(revision 477)
+++ /branches/HTM-DEV-0.3-dev2/source/Lib/TLibEncoder/TEncTop.cpp	(revision 478)
@@ -123,5 +123,4 @@
   m_cDepthMapGenerator. create( false, getSourceWidth(), getSourceHeight(), g_uiMaxCUDepth, g_uiMaxCUWidth, g_uiMaxCUHeight, g_bitDepthY, PDM_SUB_SAMP_EXP_X(m_uiPredDepthMapGeneration), PDM_SUB_SAMP_EXP_Y(m_uiPredDepthMapGeneration) );
 #endif
-
 #if RATE_CONTROL_LAMBDA_DOMAIN
   if ( m_RCEnableRateControl )
@@ -229,5 +228,4 @@
   m_cLoopFilter.        destroy();
   m_cRateCtrl.          destroy();
-
 #if H_3D_IV_MERGE
   m_cDepthMapGenerator. destroy();
@@ -322,5 +320,4 @@
   m_cDepthMapGenerator.init( (TComPrediction*)this->getPredSearch(), m_pcTAppEncTop->getVPSAccess(), m_pcTAppEncTop->getSPSAccess(), m_pcTAppEncTop->getAUPicAccess() );
 #endif
-
   // initialize transform & quantization class
   m_pcCavlcCoder = getCavlcCoder();
@@ -1334,5 +1331,3 @@
 }
 #endif
-
-
 //! \}
Index: /branches/HTM-DEV-0.3-dev2/source/Lib/TLibEncoder/TEncTop.h
===================================================================
--- /branches/HTM-DEV-0.3-dev2/source/Lib/TLibEncoder/TEncTop.h	(revision 477)
+++ /branches/HTM-DEV-0.3-dev2/source/Lib/TLibEncoder/TEncTop.h	(revision 478)
@@ -57,5 +57,4 @@
 #include "TEncPreanalyzer.h"
 #include "TEncRateCtrl.h"
-
 #if H_3D_IV_MERGE
 #include "TLibCommon/TComDepthMapGenerator.h"
@@ -71,5 +70,4 @@
 class TAppEncTop;
 #endif
-
 /// encoder class
 class TEncTop : public TEncCfg
@@ -104,9 +102,7 @@
   TEncSlice               m_cSliceEncoder;                ///< slice encoder
   TEncCu                  m_cCuEncoder;                   ///< CU encoder
-
 #if H_3D_IV_MERGE
   TComDepthMapGenerator   m_cDepthMapGenerator;           ///< depth map generator
 #endif
-
   // SPS
   TComSPS                 m_cSPS;                         ///< SPS